import processing.data.StringList;
import org.apache.tools.ant.types.resources.comparators.Date;

PFont myFont;
PFont myFont1;

int [][] dataMatrix = null;
String [][] dataMatrix1 = null;

String [] Month = {"Jan","Feb","Mar","Apr","May","Jun",
                   "Jul","Aug","Sep","Oct","Nov","Dec"};
                     
int numMonth = 12;
int numYear = 8;

int colorR = 255;
int colorG = 135;
int colorB = 25;
int barwidth = 500;

color from  = color(1,1,1);
color to = color(colorR,colorG,colorB);

int maxCount;
int numRows, numColumns;
int xPosition = 20;
int yearcut = 12;
int ycut = 5;


PFont font= createFont("Helvetica",16,true);
PFont font_1;
Table myTable;

void setup()
{
size(1340,960);
smooth();
noStroke();

myFont =createFont("Helvetica", 38);
textFont(myFont);

myTable = new Table();
myTable = loadTable( "data06-13.csv", "header"); 
numRows = myTable.getRowCount();
numColumns = myTable.getColumnCount();

dataMatrix = new int[numRows][numColumns];

for (int i = 0; i < numRows; i ++)
{
  for ( int j = 1; j < numColumns; j ++)
  {
    dataMatrix[i][j] =  myTable.getInt(i,j);
  }
}

maxCount = dataMatrix[0][0];

for (int i = 0; i < numRows; i ++)
{
  for ( int j = 1; j < numColumns; j ++)
  {
    if (dataMatrix[i][j] > maxCount)
     maxCount = dataMatrix[i][j];
  }
 }
}

void draw()
{
  colorMode(RGB);
  background(85,85,85);
  translate(200,150);
  
 
        
  
 
  
  for(int i = 0; i <numRows; i++)
  {
    for(int j = 1; j <numColumns; j++)
    {
    
     
     
      
     fill( colorR* dataMatrix[i][j] / maxCount 
      , colorG* dataMatrix[i][j] / maxCount
      , colorB* dataMatrix[i][j] / maxCount); 
        //println(360* dataMatrix[i][j] / maxCount);
        
        
    
     
     
       if(i < 12){
        rect(i*92,j*16,88,13);
        /*
         textSize(14);
         textAlign(BOTTOM);
         fill(255);
         text(dataMatrix[i][j],i*92,j*16+10);
         */
        
        
       } else if (i >= yearcut && i < yearcut*2){
        rect((i-yearcut)*92,(j+ycut)*16,88,13);
        /*
         textSize(14);
         textAlign(BOTTOM);
         fill(255);
         text(dataMatrix[i][j],(i-yearcut)*92,(j+ycut)*16+10);
        */
        
       } else if (i >= yearcut*2 && i < yearcut*3){
        rect((i-yearcut*2)*92,(j+ycut*2)*16,88,13);
        /*
        textSize(14);
         textAlign(BOTTOM);
         fill(255);
         text(dataMatrix[i][j],(i-yearcut*2)*92,(j+ycut*2)*16+10);
        */
        
       } else if (i >= yearcut*3 && i < yearcut*4){
        rect((i-yearcut*3)*92,(j+ycut*3)*16,88,13);
        /*
        textSize(14);
         textAlign(BOTTOM);
         fill(255);
         text(dataMatrix[i][j],(i-yearcut*3)*92,(j+ycut*3)*16+10);
        */
        
       } else if (i >= yearcut*4 && i < yearcut*5){
        rect((i-yearcut*4)*92,(j+ycut*4)*16,88,13);
        /*
        textSize(14);
         textAlign(BOTTOM);
         fill(255);
         text(dataMatrix[i][j],(i-yearcut*4)*92,(j+ycut*4)*16+10);
        */
        
       } else if (i >= yearcut*5 && i < yearcut*6){
        rect((i-yearcut*5)*92,(j+ycut*5)*16,88,13);
        /*
        textSize(14);
         textAlign(BOTTOM);
         fill(255);
         text(dataMatrix[i][j],(i-yearcut*5)*92,(j+ycut*5)*16+10);
        */
        
       } else if (i >= yearcut*6 && i < yearcut*7){
        rect((i-yearcut*6)*92,(j+ycut*6)*16,88,13);
        /*
        textSize(14);
         textAlign(BOTTOM);
         fill(255);
         text(dataMatrix[i][j],(i-yearcut*6)*92,(j+ycut*6)*16+10);
        */
        
       }else if (i >= yearcut*7 && i < yearcut*8){
        rect((i-yearcut*7)*92,(j+ycut*7)*16,88,13);
        /*
        textSize(14);
         textAlign(BOTTOM);
         fill(255);
         text(dataMatrix[i][j],(i-yearcut*7)*92,(j+ycut*7)*16+10);
         */
       } 
    }
  }

  
  for(int p = 0; p < numMonth; p++){
    
  textFont(myFont);
  fill(133,203,43);
  textAlign(UP);
  textFont(myFont,28);
  text(Month[p],p*92,-5);
  }
  for(int k = 0; k <numYear; k ++){
  text(2006+k, -110, k*80+58);  
  }
  for(int t = 0; t <numYear; t ++){
  myFont1 = createFont("Helvetica-Bold",12);
  textSize(12);
  textFont(myFont1);
  text("C\nU\nJ\nH", -20, t*80+28);
  }
  textSize(32);
  text("Comic books checkout", -174, -110);
  
  textFont(myFont1);
  text("C = Comic books [741.5]\nU = Comic books - US [741.5973]\nJ = Comic books - Japan [741.5952]\nH = Harry Potter books",-170,-90); 
 
   
  for(int q = 1; q < barwidth; q++){
   color inter=lerpColor(from,to,(float(q)/barwidth));
   noStroke();
   fill(inter);
   rect(q+600,-100, 1,20);
   
   
   
  }
  
   
    textAlign(CENTER);
    fill(133,203,43);
    text("0",600,-110);
    text("10000",600+500*10000/maxCount,-110);
    text("20000",600+500*20000/maxCount,-110);
    text("30000",600+500*30000/maxCount,-110);
    text(maxCount,600+500,-110);

  
    
  
  
  save("hw2-3.jpg");
}
